//   ,  
//   
// (c) Proteus   lawnmower-man@mail.ru  icq:133575351

#include<stdio.h>
#include<stdlib.h>
#include<time.h>

#define SIZE 9000	//!<  

// h -  = -1 -  
// value - 
// p1,p2   
// tree[p1].value < tree[p2].value
struct node_st{ int p1,p2; int value; int h;}; //!<  
node_st tree[SIZE]; //!<  

int free_index=0;	//!<  
int root_index=-1;	//!< 

inline int max(int a,int b) {return a>b?a:b;}

#define ERROR_BALANCE	-1	//!<  
#define ERROR_H			-2	//!<   
#define ERROR_RELATIONS	-3	//!<   

void Clear();
int Rotate12(int index,bool sub);
int Rotate21(int index,bool sub);
bool Insert(int value,int *root);
bool Remove(int *root,int value);


//   (     )
int turn_count;		//!<     
int max_count;		//!<     
int sum_count;		//!<   
int sum_divider;	//!<  ,   

//=====  ! ========================

//!   
//!    ,    
int NewItem(int value)
{
	if(free_index>=SIZE) { printf("out of memory\n\a"); getchar(); exit(-1);}
	tree[free_index].value=value;
	tree[free_index].p1=tree[free_index].p2=-1;
	tree[free_index].h=1;
	return free_index++;
}

//!  
void DelItem(int index)
{
	tree[index].h=-1;
}

//!   ( )
void Clear(int index)
{
	if(index<0) return;
	Clear(tree[index].p1);
	Clear(tree[index].p2);
	DelItem(index);
}

//!  
void Clear()
{
	Clear(root_index);
	root_index=free_index=0;
}



//!  ,  
//! \param index  
//! \param depth 
//! \param dir   
//! \code Show(root,0,'*'); \endcode
void Show(int index,int depth,char dir)
{
	int n;
	if(index<0) return;
	for(n=0; n<depth; n++) putchar(' ');
	printf("%c[%d] (%d)\n",dir,tree[index].value,tree[index].h);
	Show(tree[index].p1,depth+1,'-');
	Show(tree[index].p2,depth+1,'+');
}

//!<   
void SetH(int index)
{
	int h1,h2,i;
	h1=h2=0;
	i=tree[index].p1; if(i>=0) h1=tree[i].h;
	i=tree[index].p2; if(i>=0) h2=tree[i].h;
	tree[index].h=max(h1,h2)+1;
}


//!  
//! \param index  
//! \param sub     
//! \result    
int Rotate21(int index,bool sub)
{
	int i2=tree[index].p2;
	int i21=tree[i2].p1;
	int i22=tree[i2].p2;
	if(sub && i21>=0 && tree[i22].h<tree[i21].h) {
		i2=tree[index].p2=Rotate12(i2,false);
		i21=tree[i2].p1;
	}
	tree[i2].p1=index;
	tree[index].p2=i21;
	SetH(index);
	return i2;
}

//!  
//! \param index  
//! \param sub     
//! \result    
int Rotate12(int index,bool sub)
{
	int i1,i11,i12;
	i1=tree[index].p1;
	i11=tree[i1].p1;
	i12=tree[i1].p2;
	if(sub && i12>=0 && tree[i11].h<tree[i12].h) {
		i1=tree[index].p1=Rotate21(i1,false);
		i12=tree[i1].p2;
	}
	tree[i1].p2=index;
	tree[index].p1=i12;
	SetH(index);
	return i1;
}

//!    
void Balance(int *root)
{
	int r=0;
	int index=*root;  int h1,h2,i;
	i=tree[index].p1; h1=i<0?0:tree[i].h;
	i=tree[index].p2; h2=i<0?0:tree[i].h;
	if(abs(h1-h2)>1) {
		if(h1<h2)*root=Rotate21(index,true);
		if(h1>h2)*root=Rotate12(index,true);
		turn_count++;
	}
	SetH(*root);
}

//!   
//! \result true      
bool Insert(int value,int *root)
{
	int index=*root;
	if(index<0) *root=NewItem(value);
	else {
		if(value==tree[index].value) return true; 
		if(Insert(value,value<tree[index].value?&tree[index].p1:&tree[index].p2)) return true;
		Balance(root);
	}
	return false;
}

//!<      
int GetMin(int *root)
{
	int index=*root;
	if(tree[index].p1>=0) index=GetMin(&tree[index].p1),Balance(root);
	else *root=tree[index].p2;
	return index;
}


//!   
//! \result false     
bool Remove(int *root,int value)
{
	bool ok=false;
	int index=*root;
	if(index<0) return ok;
	if(tree[index].value<value) ok=Remove(&tree[index].p2,value); else
	if(tree[index].value>value) ok=Remove(&tree[index].p1,value); else
	//if(node->value==value) 
	{
		if(tree[index].p2<0) {*root=tree[index].p1;DelItem(index);return true;}
		ok=true;
		*root=GetMin(&tree[index].p2);
		tree[*root].p1=tree[index].p1;
		tree[*root].p2=tree[index].p2;
		DelItem(index);
	} 
	if(ok) Balance(root);
	return ok;

}


//=====     ! ===============

//!  
void Show()
{
	Show(root_index,0,'*');
}

//!  
//! \result =true   
bool Insert(int value)
{
	turn_count=0;
	if(Insert(value,&root_index)) return false;
	if(max_count<turn_count) max_count=turn_count;
	sum_count+=turn_count; sum_divider++;
	return true;
}

//!  
//! \result =true   
bool Remove(int value)
{
	turn_count=0;
	if(!Remove(&root_index,value)) return false;
	if(max_count<turn_count) max_count=turn_count;
	sum_count+=turn_count; sum_divider++;
	return true;
}


//===== ! ==================================

//!   
//! \result     
int Check(int index)
{
	int h1=0,h2=0,h=0,i;
	i=tree[index].p1; if(i>=0) {h1=Check(i); if(h1<0) return h1; if(tree[index].value<=tree[i].value) return ERROR_RELATIONS;}
	i=tree[index].p2; if(i>=0) {h2=Check(i); if(h2<0) return h2; if(tree[index].value>=tree[i].value) return ERROR_RELATIONS;}
	if(abs(h1-h2)>1) return ERROR_BALANCE;
	h=(h1>h2?h1:h2)+1;
	if(h!=tree[index].h) return ERROR_H;
	return h;
}

//!       
//! \param list  
//! \param index   
//! \param root    
void TreeWalk(int *list,int &index,int limit,int root)
{
	if(root<0) return;
	TreeWalk(list,index,limit,tree[root].p1);
	if(index<0 || index>=limit) {index=-1;return;}
	list[index++]=tree[root].value;
	TreeWalk(list,index,limit,tree[root].p2);
}

//!    
//! \param list1 
//! \param root   
//! \result   , -1   
int Compare(int *list1,int size,int root)
{
	int n,m,t; int *list2=0;
	for(n=0; n<size; n++) for(m=n+1; m<size; m++) {	// 
		if(list1[n]>list1[m]) t=list1[n],list1[n]=list1[m],list1[m]=t;
	}
	list2=new int[size]; 
	n=0; TreeWalk(list2,n,size,root_index);
	if(n!=size) return size;
	for(n=0; n<size; n++) {if(list1[n]!=list2[n]) return n;}
	delete[]list2;
	return -1;
}


//!    
void Stat()
{
	int n=Check(root_index);
	printf("check value: ");
	switch(n) {
	case ERROR_BALANCE:   printf("error balance\n"); break;
	case ERROR_H:		  printf("error h\n"); break;
	case ERROR_RELATIONS: printf("error relations\n"); break;
	default: printf("OK (%d)\n",n); break;
	}	
	printf("max turn count: %d\n",max_count);
	printf("average turn count: %f\n",(double)sum_count/sum_divider);
}

//!  
void Reset()
{
	max_count=sum_count=sum_divider=0;
}


//!    
void main()
{
	srand(clock());
	int array[SIZE+1]; int n,m,count,v;
	Reset();
	free_index=0; root_index=-1;
	printf("=== insert\n");
	for(n=count=0; n<SIZE; n++) {
		v=rand()%(SIZE+SIZE/2);
		if(Insert(v)) array[count++]=v;
	}
	printf("nodes: %d\n",count);
	Stat();
	Reset();
	printf("=== remove\n");
	for(n=0; n<SIZE/2; n++) {
		m=rand()%count; v=array[m]; if(v<0) continue;
		array[m]=-1; Remove(v);
	}
	for(n=m=0; n<count; n++) { //  ,   
		if(array[n]>=0) array[m++]=array[n];
	}
	count=m;
	printf("nodes: %d\n",count);
	Stat();
	n=Compare(array,count,root_index);
	if(n<0) printf("Check Nodes: ok\n"); else printf("Internal error [%d]\n\a",n); 
	Clear();
	getchar();
}



